VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClipboardSnapshot"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'
' ClipboardSnapshot.CLS
'
' class to hold a copy of the data stored
' on the clipboard
'
' because we have to use the clipboard to
' paste the icon onto the command bar for
' these add-ins, I wanted something that
' I could use to save and restore the
' clipboard data.  I know that this isn't
' a complete capturing of the clipboard
' data, but it'll have to do
'



Private bDataValid(0 To 8) As Boolean
Private picClipboardData(0 To 8) As StdPicture
Private cClipboardText(0 To 8) As String
Private bDataSaved As Boolean


'
' public routines
'
Public Property Get DataSaved() As Boolean
    DataSaved = bDataSaved
End Property
    
Public Sub SaveClipboardData()

    Dim nFormat As Long
    Dim i As Long
    
    
    On Error Resume Next
    
    For i = 0 To 8
        
        bDataValid(i) = False
        nFormat = ClipboardFormat(i)
        If Clipboard.GetFormat(nFormat) = True Then
        ' we have data -- try and get it
        
            If IsImageFormat(nFormat) Then
            ' try to grab the picture
                Err.Clear
                Set picClipboardData(i) = Clipboard.GetData(nFormat)
                bDataValid(i) = CBool(Err.Number = 0)
            ElseIf IsTextFormat(nFormat) Then
            ' try to grab the text
                Err.Clear
                cClipboardText(i) = Clipboard.GetText(nFormat)
                bDataValid(i) = CBool(Err.Number = 0)
            End If
            
        End If ' have data
        
    Next ' i
        
    bDataSaved = True
    On Error GoTo 0

End Sub

Public Sub RestoreClipboardData()
' try to return all of the data back to the clipboard

    Dim i As Long
    Dim nFormat As Long
    
    On Error Resume Next
    
    
    If bDataSaved = False Then Exit Sub
    
    For i = 0 To 8
        If bDataValid(i) Then
            nFormat = ClipboardFormat(i)
            If IsImageFormat(nFormat) Then
                Clipboard.SetData picClipboardData(i), nFormat
            ElseIf IsTextFormat(nFormat) Then
                Clipboard.SetText cClipboardText(i), nFormat
            End If
        End If
    Next ' i
    
    On Error GoTo 0
    
End Sub


'
' support routines
'
Private Function ClipboardFormat(ByVal FormatIndex As Long) As VBRUN.ClipBoardConstants

    Select Case FormatIndex
        Case 0
            ClipboardFormat = vbCFBitmap
        Case 1
            ClipboardFormat = vbCFDIB
        Case 2
            ClipboardFormat = vbCFEMetafile
        Case 3
            ClipboardFormat = vbCFFiles
        Case 4
            ClipboardFormat = vbCFLink
        Case 5
            ClipboardFormat = vbCFMetafile
        Case 6
            ClipboardFormat = vbCFPalette
        Case 7
            ClipboardFormat = vbCFRTF
        Case 8
            ClipboardFormat = vbCFText
    End Select

End Function

Private Function FormatIndex(ByVal ClipboardFormat As VBRUN.ClipBoardConstants) As Integer

    Select Case ClipboardFormat
        Case vbCFBitmap
            FormatIndex = 0
        Case vbCFDIB
            FormatIndex = 1
        Case vbCFEMetafile
            FormatIndex = 2
        Case vbCFFiles
            FormatIndex = 3
        Case vbCFLink
            FormatIndex = 4
        Case vbCFMetafile
            FormatIndex = 5
        Case vbCFPalette
            FormatIndex = 6
        Case vbCFRTF
            FormatIndex = 7
        Case vbCFText
            FormatIndex = 8
    End Select

End Function

Private Function IsImageFormat(ByVal ClipboardFormat As VBRUN.ClipBoardConstants) As Boolean

    Select Case ClipboardFormat
        Case vbCFBitmap, vbCFDIB, vbCFEMetafile, vbCFMetafile, vbCFPalette
            IsImageFormat = True
        Case Else
            IsImageFormat = False
    End Select
        
End Function

Private Function IsTextFormat(ByVal ClipboardFormat As VBRUN.ClipBoardConstants) As Boolean

    Select Case ClipboardFormat
        Case vbCFLink, vbCFRTF, vbCFText
            IsTextFormat = True
        Case Else
            IsTextFormat = False
    End Select
        
End Function
