VERSION 5.00
Begin VB.Form frmOptions 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "IDE Mouse Wheel Options"
   ClientHeight    =   1965
   ClientLeft      =   8700
   ClientTop       =   4950
   ClientWidth     =   5520
   Icon            =   "frmOptions.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1965
   ScaleWidth      =   5520
   ShowInTaskbar   =   0   'False
   Begin VB.CheckBox chkScrollInWindowOnly 
      Caption         =   "Only scroll when cursor is over editor &window"
      Height          =   285
      Left            =   180
      TabIndex        =   3
      Top             =   180
      Width           =   3885
   End
   Begin VB.CheckBox chkCtrlKeyScrollsOther 
      Caption         =   "Ctrl key scrolls &other pane"
      Height          =   285
      Left            =   405
      TabIndex        =   6
      Top             =   1230
      Width           =   2580
   End
   Begin VB.ComboBox cboSplitOptions 
      Height          =   315
      ItemData        =   "frmOptions.frx":628A
      Left            =   180
      List            =   "frmOptions.frx":6297
      Style           =   2  'Dropdown List
      TabIndex        =   5
      Top             =   870
      Width           =   3810
   End
   Begin VB.CommandButton cmdApply 
      Caption         =   "&Apply"
      Height          =   345
      Left            =   4260
      TabIndex        =   2
      Top             =   1200
      Width           =   1140
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   345
      Left            =   4260
      TabIndex        =   1
      Top             =   615
      Width           =   1140
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   4260
      TabIndex        =   0
      Top             =   180
      Width           =   1140
   End
   Begin VB.Label lblVersion 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "lblVersion"
      ForeColor       =   &H80000015&
      Height          =   195
      Left            =   4725
      TabIndex        =   8
      Top             =   1650
      Width           =   675
   End
   Begin VB.Label lblDefaults 
      AutoSize        =   -1  'True
      Caption         =   "Restore Defaults"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   195
      Left            =   120
      MouseIcon       =   "frmOptions.frx":6305
      MousePointer    =   99  'Custom
      TabIndex        =   7
      Top             =   1650
      Width           =   1185
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "&Split code window options:"
      Height          =   195
      Left            =   180
      TabIndex        =   4
      Top             =   630
      Width           =   1890
   End
End
Attribute VB_Name = "frmOptions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'
' frmOptions.FRM
'
' options dialog for the IDE Mousewheel Addin
'
'


'
' form events
'
Private Sub Form_Load()
' fetch the settings, center the form


    ' load settings
    ' ugly code alert - we should use constants
    '
    If modIDEMouseWheel.UseCursorPosition Then
        cboSplitOptions.ListIndex = 2
        chkCtrlKeyScrollsOther.Enabled = True
    ElseIf modIDEMouseWheel.CtrlKeyScrollsBottom Then
        cboSplitOptions.ListIndex = 1
        chkCtrlKeyScrollsOther.Enabled = False
    Else
        cboSplitOptions.ListIndex = 0
        chkCtrlKeyScrollsOther.Enabled = False
    End If
        
    chkCtrlKeyScrollsOther.Value = modIDEMouseWheel.CtrlKeyScrollsOther And vbChecked
    chkScrollInWindowOnly.Value = modIDEMouseWheel.ScrollInWindowOnly And vbChecked
    
    
    ' center on top half of screen, reset apply button
    '
    Me.Move (Screen.Width - Me.Width) \ 2, ((Screen.Height \ 2) - Me.Height) \ 2
    lblVersion.Caption = "version " & App.Major & "." & App.Minor & " build " & Format$(App.Revision, "0000")
    cmdApply.Enabled = False
    
End Sub


'
' command button events
'
Private Sub cmdApply_Click()
' save settings (more ugly code)

    modIDEMouseWheel.CtrlKeyScrollsBottom = CBool(cboSplitOptions.ListIndex = 1)
    modIDEMouseWheel.UseCursorPosition = CBool(cboSplitOptions.ListIndex = 2)
    modIDEMouseWheel.CtrlKeyScrollsOther = CBool(chkCtrlKeyScrollsOther.Value = vbChecked)
    modIDEMouseWheel.ScrollInWindowOnly = CBool(chkScrollInWindowOnly.Value = vbChecked)
    
    modIDEMouseWheel.SaveSettings
    If cmdOK.Visible Then cmdOK.SetFocus
    cmdApply.Enabled = False

End Sub

Private Sub cmdCancel_Click()
    cmdApply.Enabled = False
    Me.Hide
    Unload Me
End Sub

Private Sub lblDefaults_Click()
' set default values

    cboSplitOptions.ListIndex = 0
    chkCtrlKeyScrollsOther.Value = vbUnchecked
    chkScrollInWindowOnly.Value = vbUnchecked

End Sub

Private Sub cmdOK_Click()
' save changes, then unload

    If cmdApply.Enabled Then cmdApply_Click
    cmdCancel_Click

End Sub



'
' contained control events
'
Private Sub cboSplitOptions_Change()
    chkCtrlKeyScrollsOther.Enabled = CBool(cboSplitOptions.ListIndex = 2)
    cmdApply.Enabled = True
End Sub

Private Sub cboSplitOptions_Click()
    cboSplitOptions_Change
End Sub

Private Sub chkCtrlKeyScrollsOther_Click()
    cmdApply.Enabled = True
End Sub

Private Sub chkScrollInWindowOnly_Click()
    cmdApply.Enabled = True
End Sub

