Attribute VB_Name = "modMessageHook"
Option Explicit

'
' modMessageHook.BAS
'
' a thread-level message hook.  in our case,
' we're gonna do something whenever we get
' the mousewheel roll message
'
'




' api declares (not in win32.tlb)
'
Public Type POINTAPI
    x As Long
    y As Long
End Type

Public Type MSG
    hWnd As Long
    Message As Long
    wParam As Long
    lParam As Long
    time As Long
    pt As POINTAPI
End Type

Private Const WH_GETMESSAGE = 3

Private Declare Function CallNextHookEx& Lib "user32" (ByVal hHook As Long, ByVal nCode As Long, ByVal wParam As Integer, lParam As Any)
Private Declare Function GetCurrentThreadId Lib "kernel32" () As Long
Private Declare Function SetWindowsHookEx& Lib "user32" Alias "SetWindowsHookExA" (ByVal idHook As Long, ByVal lpfn As Long, ByVal hmod As Long, ByVal dwThreadId As Long)
Private Declare Function UnhookWindowsHookEx& Lib "user32" (ByVal hHook As Long)
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)


'
' members
'
Private hHook As Long
Private bHooked As Boolean
Private nHookMessage As Long


'
' functions
'
Public Sub StartHook(ByVal HookMessage As Long)
' starts our message hook

    If bHooked = False Then
        
        If HookMessage = 0 Then Err.Raise 380, "HookMessage cannot be 0."
        nHookMessage = HookMessage
        
        hHook = SetWindowsHookEx(WH_GETMESSAGE, AddressOf MsgHookProc, 0, GetCurrentThreadId)
        If hHook = 0 Then
            Debug.Print "SetWindowsHookEx failed."
            nHookMessage = 0
        Else
            bHooked = True
        End If
    
    End If
    
End Sub

Public Sub StopHook()
' stops our message hook

    If bHooked = True Then
        UnhookWindowsHookEx hHook
        hHook = 0
        nHookMessage = 0
    End If

End Sub

Public Function MsgHookProc(ByVal nCode As Long, ByVal wParam As Long, lParam As MSG) As Long
' actual hook procedure itself (called all the time)

    
    On Error GoTo errHand
    
    
    ' call the next hook procedure right away
    '
    MsgHookProc = CallNextHookEx(hHook, nCode, wParam, lParam)
    
    ' if the message matches our public variable, and it's a code window,
    ' then call the mousewheel addin
    '
    If lParam.Message = nHookMessage Then
        If modSupport.IsCodeWindow(lParam.hWnd) Then modIDEMouseWheel.DoScroll lParam
    End If
    
    Exit Function
    
errHand:
    win.OutputDebugString "MsgHookProc Error " & Err.Number & ": " & Err.Description
    Resume Next
End Function
